//////////////////////////////////////////////////////////////////////////////
// display.c                                                                //
//////////////////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////////////////////
// includes                                                                 //
//////////////////////////////////////////////////////////////////////////////
#include <gb.h>
#include "display.h"

//////////////////////////////////////////////////////////////////////////////
// defines                                                                  //
//////////////////////////////////////////////////////////////////////////////
// DMA: xxx0..xxx0 -> 8xx0..9xx0, size: 16..2048
#define GPDMA(src,dest,size) \
	*(UBYTE*)0xFF51 = (unsigned long)(src)>>8; \
	*(UBYTE*)0xFF52 = (unsigned long)(src)&0xFF; \
	*(UBYTE*)0xFF53 = (unsigned long)(dest)>>8; \
	*(UBYTE*)0xFF54 = (unsigned long)(dest)&0xFF; \
	*(UBYTE*)0xFF55 = (size)/16-1;

// HDMA: xxx0..xxx0 -> 8xx0..9xx0, size: 16..2048
#define HDMA(src,dest,size) \
	*(UBYTE*)0xFF51 = (unsigned long)(src)>>8; \
	*(UBYTE*)0xFF52 = (unsigned long)(src)&0xFF; \
	*(UBYTE*)0xFF53 = (unsigned long)(dest)>>8; \
	*(UBYTE*)0xFF54 = (unsigned long)(dest)&0xFF; \
	*(UBYTE*)0xFF55 = 128 + (size)/16-1;

#define POS(map,ix,iy) ( (unsigned long) &(*(map))[iy][ix] )
#define SPRT(pos) ( *(char*) ((unsigned long)(sprtmap) + (pos)) )
#define ATTR(pos) ( *(char*) ((unsigned long)(attrmap) + (pos)) )
#define TILE(pos) ( *(char*) ((unsigned long)(tilemap) + (pos)) )

//////////////////////////////////////////////////////////////////////////////
// variables                                                                //
//////////////////////////////////////////////////////////////////////////////
extern unsigned char gridPLN0[18][32];

extern int scx;

//////////////////////////////////////////////////////////////////////////////
// InitMaps1                                                                //
//////////////////////////////////////////////////////////////////////////////
void InitMaps1()
{
	unsigned int x,y;
	for (y=0; y<18; y++)
	{
		for (x=0; x<25; x++)
		{
			gridmap[y][x] = gridPLN0[y][x];
			tilemap[y][x] = gridmap[y][x];
			attrmap[y][x] = 0;
			sprtmap[y][x] = -1;
		}
	}
}

//////////////////////////////////////////////////////////////////////////////
// InitMaps2                                                                //
//////////////////////////////////////////////////////////////////////////////
/*void InitMaps2()
{
	unsigned int x,y;
	for (y=5; y<=14; y++)
	{
		for (x=0; x<24; x++)
		{
			tilemap[y][x] = gridPLN0[y][x];
			attrmap[y][x] = gridPLN1[y][x];
			sprtmap[y][x] = -1;
		}
	}
}*/
