//////////////////////////////////////////////////////////////////////////////
// puzzles.c                                                                //
//////////////////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////////////////////
// includes                                                                 //
//////////////////////////////////////////////////////////////////////////////
#include "stdafx.h"
#include "puzzle.h"
#include "sound.h"

//////////////////////////////////////////////////////////////////////////////
// Special1                                                                 //
//////////////////////////////////////////////////////////////////////////////
void Special1()
{
	puzzle.map[2][2] = 1;
	puzzle.map[2][6] = 2;
	puzzle.map[6][2] = 4;
}

//////////////////////////////////////////////////////////////////////////////
// variables                                                                //
//////////////////////////////////////////////////////////////////////////////
Puzzle puzzle;							// current puzzle status
Puzzle undo;							// undo puzzle status
Puzzle *orgpuzzle;						// pointer to original puzzle
extern int edit;

//////////////////////////////////////////////////////////////////////////////
// SaveUndo                                                                 //
//////////////////////////////////////////////////////////////////////////////
void SaveUndo()
{
	memcpy(&undo, &puzzle, sizeof(puzzle));
}

//////////////////////////////////////////////////////////////////////////////
// LoadUndo                                                                 //
//////////////////////////////////////////////////////////////////////////////
void LoadUndo()
{
	memcpy(&puzzle, &undo, sizeof(puzzle));
}

//////////////////////////////////////////////////////////////////////////////
// SavePuzzle                                                               //
//////////////////////////////////////////////////////////////////////////////
void SavePuzzle()
{
	ENABLE_RAM;
	*orgpuzzle = puzzle;
	DISABLE_RAM;
}

//////////////////////////////////////////////////////////////////////////////
// ValidPuzzle                                                              //
//////////////////////////////////////////////////////////////////////////////
int ValidPuzzle()
{
	if (puzzle.title[19] != 0) return 0;
	if (puzzle.whites == 0) return 0;
	return -1;
}

//////////////////////////////////////////////////////////////////////////////
// LoadPuzzle                                                               //
//////////////////////////////////////////////////////////////////////////////
void LoadPuzzle()
{
	ENABLE_RAM;
	puzzle = *orgpuzzle;
	DISABLE_RAM;

	if (!ValidPuzzle())	// clear invalid puzzle
	{
		unsigned int x,y, n;
		for (y=0; y<DEPTH; y++)
		{
			for (x=0; x<WIDTH; x++)
			{
				puzzle.map[y][x] = 0;
			}
		}
		strcpy(puzzle.title, "    'No name 00'   \0");
		n = ((unsigned long)orgpuzzle-(unsigned long)rampuzzles) / sizeof(Puzzle) + 1;
		puzzle.title[13] = '0' + n/10;
		puzzle.title[14] = '0' + n%10;
		puzzle.x = puzzle.y = 4;
		puzzle.whites = 20;
		puzzle.special = 0;
	}
}

//////////////////////////////////////////////////////////////////////////////
// PrevPuzzle                                                               //
//////////////////////////////////////////////////////////////////////////////
int PrevPuzzle()
{
	if (orgpuzzle == rampuzzles)
		orgpuzzle = &puzzles[PUZZLES-1];
	else if (orgpuzzle != &puzzles[0])
		orgpuzzle--;
	else
		return -1;
	return 0;
}

//////////////////////////////////////////////////////////////////////////////
// NextPuzzle                                                               //
//////////////////////////////////////////////////////////////////////////////
int NextPuzzle()
{
	if (orgpuzzle == &puzzles[PUZZLES-1])
		orgpuzzle = rampuzzles;
	else
	{
		if (orgpuzzle < (Puzzle*)0xBF00) orgpuzzle++; else return -1;
	}
	return 0;
}

//////////////////////////////////////////////////////////////////////////////
// SelectPuzzle                                                             //
//////////////////////////////////////////////////////////////////////////////
void SelectPuzzle()
{
	PlaySound(FADEIN);
	clrscr();
	Loadpuzzle();
	gotoxy(0,8); printf(puzzle.title);
	FadeUp(1);
	while (1)
	{
		unsigned int joy = joypad();

		if ((joy & J_SELECT) && (orgpuzzle >= rampuzzles))
		{
			gotoxy(4,9); printf("(edit mode)");
			edit=1;
			break;
		}
		
		if ((joy & J_START) || (joy & J_A) || (joy & J_B))
		{
			PlaySound(SELECT);
			edit=0; break;
		}

		if (joy & J_LEFT)
		{
			PlaySound(ROTATE);
			PrevPuzzle();
			FadeDown(3);
			Loadpuzzle();
			gotoxy(0,8); printf(puzzle.title);
			FadeUp(3);
		}

		if (joy & J_RIGHT)
		{
			PlaySound(ROTATE);
			NextPuzzle();
			FadeDown(3);
			Loadpuzzle();
			gotoxy(0,8); printf(puzzle.title);
			FadeUp(3);
		}
	}
	FadeDown(1);
}
