//////////////////////////////////////////////////////////////////////////////
// puzzles.h                                                                //
//////////////////////////////////////////////////////////////////////////////
#ifndef _PUZZLES_H
#define _PUZZLES_H

//////////////////////////////////////////////////////////////////////////////
// defines                                                                  //
//////////////////////////////////////////////////////////////////////////////
#define WIDTH		8
#define DEPTH		8
#define PUZZLES		21		// !!!!!!
#define rampuzzles (Puzzle*)0xA000		// first puzzle in back-up RAM

//////////////////////////////////////////////////////////////////////////////
// typedefs                                                                 //
//////////////////////////////////////////////////////////////////////////////
typedef struct
{
	char id[3], crc;
	char title[20];
	int x,y;
	int whites;
	int special;
	int pad[4];
	unsigned int map[DEPTH][WIDTH];
} Puzzle;

//////////////////////////////////////////////////////////////////////////////
// variables                                                                //
//////////////////////////////////////////////////////////////////////////////
extern Puzzle puzzle;						// current puzzle status
extern Puzzle undo;							// undo puzzle status
extern Puzzle *orgpuzzle;					// pointer to original puzzle
extern Puzzle puzzles[PUZZLES];

//////////////////////////////////////////////////////////////////////////////
// prototypes                                                               //
//////////////////////////////////////////////////////////////////////////////
void SaveUndo();
void LoadUndo();
int PrevPuzzle();
int NextPuzzle();
void SelectPuzzle();

#endif // _PUZZLES_H
