//////////////////////////////////////////////////////////////////////////////
// sound.h                                                                  //
//////////////////////////////////////////////////////////////////////////////
#ifndef _SOUND_H
#define _SOUND_H

//////////////////////////////////////////////////////////////////////////////
// includes                                                                 //
//////////////////////////////////////////////////////////////////////////////
#include "makefile.h"	// bank definitions

//////////////////////////////////////////////////////////////////////////////
// sound defines                                                            //
//////////////////////////////////////////////////////////////////////////////
#define EXPLODE		9,		explode,	EXPLODE_BNK
#define FADEIN		9,		fadein,		FADEIN_BNK
#define FADEOUT		9,		fadeout,	FADEOUT_BNK
#define MOVE1		1,		move1,		MOVE1_BNK
#define MOVE2		2,		move2,		MOVE2_BNK
#define MOVE3		3,		move3,		MOVE3_BNK
#define NO1			1,		no1,		NO1_BNK
#define ROTATE		9,		rotate,		ROTATE_BNK
#define SELECT		9,		select,		SELECT_BNK
#define STEP1		3,		step1,		STEP1_BNK
#define STEP2		3,		step2,		STEP2_BNK
#define STEP3		3,		step3,		STEP3_BNK
#define STEP4		3,		step4,		STEP4_BNK
#define PICKUP		9,		pickup,		PICKUP_BNK
#define SECRET		9,		secret,		SECRET_BNK

//////////////////////////////////////////////////////////////////////////////
// import sounds                                                            //
//////////////////////////////////////////////////////////////////////////////
extern unsigned char explode[];
extern unsigned char fadein[];
extern unsigned char fadeout[];
extern unsigned char move1[];
extern unsigned char move2[];
extern unsigned char move3[];
extern unsigned char no1[];
extern unsigned char rotate[];
extern unsigned char select[];
extern unsigned char step1[];
extern unsigned char step2[];
extern unsigned char step3[];
extern unsigned char step4[];
extern unsigned char pickup[];
extern unsigned char secret[];

//////////////////////////////////////////////////////////////////////////////
// variables                                                                //
//////////////////////////////////////////////////////////////////////////////
extern unsigned int soundpriority;
extern void *soundptr;
extern unsigned long soundblocks;
extern unsigned int soundbank;
extern unsigned int soundoldbank;

//////////////////////////////////////////////////////////////////////////////
// SOUND_PLAYING                                                            //
//////////////////////////////////////////////////////////////////////////////
#define WAIT_SOUND() \
	while (soundblocks != 0)

//////////////////////////////////////////////////////////////////////////////
// prototypes                                                               //
//////////////////////////////////////////////////////////////////////////////
void InitSound();
int PlaySound(unsigned int priority, void *data, unsigned int bank);
void FinishSound();
void WaveIrq();

#endif // _SOUND_H
