;////////////////////////////////////////////////////////////////////////////;
;/ SOUND.S                                                                  /;
;////////////////////////////////////////////////////////////////////////////;
	.include "c:\dev\gb\lib\global.s"
	.globl	_currentbank

;////////////////////////////////////////////////////////////////////////////;
	.area	_BSS
;////////////////////////////////////////////////////////////////////////////;
_soundpriority::	;current priority
	.ds	1
_soundbank::
	.ds 1
_soundptr::
	.ds 2
_soundblocks::		;blocks to go, 0=nothing playing
	.ds 2

;////////////////////////////////////////////////////////////////////////////;
	.area	_CODE
;////////////////////////////////////////////////////////////////////////////;

;////////////////////////////////////////////////////////////////////////////;
;/ WaveHandler                                                              /;
;////////////////////////////////////////////////////////////////////////////;
.WaveHandler::
	ei			;VBL & LCD irq's don't switch banks
	push af
	push bc
	
	ld	a, (_soundblocks+0)
	ld	b, a
	ld	a, (_soundblocks+1)
	or	a, b
	jr	z, .noblocks

	push hl
		
	ld	a, (_soundptr+0)
	ld	l, a
	ld	a, (_soundptr+1)
	ld	h, a
	
	ld	c, #0x30
	ld	b, #16
	
	ld	a, (_soundbank)
	ld	(0x2000), a
	
	xor	a, a
	ldh	(.NR30), a		;disable sound 3
.copy:
	ld	a, (hl+)
	ldh	(c), a
	inc	c
	dec	b
	jr	nz, .copy
	
	ld	a, #0x80		;enable sound 3
	ldh	(.NR30), a
	
	ld	a, #0x87		;restart playing block (bit 0-6: frequency MSB)
	ldh	(.NR34), a
	
	ld	a, (_currentbank)
	ld	(0x2000), a
	
	ld	a, l
	ld	(_soundptr), a
	ld	a, h
	ld	(_soundptr+1), a
	
	ld	hl, #_soundblocks
	dec	(hl)
	jr	nz, .notlastblock	;+1
	inc	hl
	dec	(hl)
	jr	nz, .notlastblock	;+1
	xor	a, a
	ldh	(.NR30), a		;disable sound 3
.notlastblock:
	
	pop	hl
.noblocks:

	pop	bc
	pop	af
	reti
