//////////////////////////////////////////////////////////////////////////////
// SOUNDC.C                                                                 //
//////////////////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////////////////////
// includes                                                                 //
//////////////////////////////////////////////////////////////////////////////
#include "stdafx.h"
#include "sound.h"
#include "asm.h"

//////////////////////////////////////////////////////////////////////////////
// InitSound                                                                //
//////////////////////////////////////////////////////////////////////////////
void InitSound()
{
	NR52_REG |= 0x84;		// enable sound 3
	NR50_REG = 7<<4 | 7;	// SO1 & SO2 volume
	NR51_REG |= 4<<4 | 4;	// sound 3 to SO1 & SO2

	NR30_REG = 0x00;		// sound 3 - output stop
	NR31_REG = 0x80;		// sound 3 - sound length
	NR32_REG = 0x20;		// sound 3 - output level
	NR33_REG = 0x00;		// sound 3 - frequency LSB
	
	soundbank = 0;
	soundblocks = 0;
	
	//add_tim(WaveIrq);
	TMA_REG = 256-16;	// 256Hz
	TAC_REG = 0x04;		// 4KHz
	IF_REG &=~ TIM_IFLAG;
	IE_REG |= TIM_IFLAG;
}

//////////////////////////////////////////////////////////////////////////////
// PlaySound                                                                //
//////////////////////////////////////////////////////////////////////////////
int PlaySound(unsigned int priority, void *data, unsigned int bank)
{
	unsigned int oldbank;
	if (soundblocks > 0) if (priority < soundpriority) return -1;
	soundpriority = priority;
	oldbank = currentbank;
	disable_interrupts();
	soundbank = bank;
	SWITCH_ROM(soundbank);
	soundptr = (long*)data+1;
	soundblocks = *(long*)data;
	SWITCH_ROM(oldbank);
	enable_interrupts();
	return 0;
}
